--
-- Author: Mars
-- Date: 2014-11-06 15:27:06
--

require("AudioEngine")
require("math")
require("json")
require("extern")

-- 跟踪错误信息
function __G__TRACKBACK__(msg)
print("----------------------------------------")
print("LUA ERROR: " .. tostring(msg) .. "\n")
print(debug.traceback())
print("----------------------------------------")
end

CHANNEL_NAME = ""
PLATFORM=""

local function main()

    -- 防止内存泄露
    collectgarbage("setpause", 100)
    collectgarbage("setstepmul", 5000)

    ---------------
    math.randomseed(os.date("%d%H%M%S"))

    -- 获取屏幕的大小
    local winSize = CCDirector:sharedDirector():getWinSize()
    
    -- 开始这个场景
    local systemInfo    = PlatformUtil:callPlatformFunction("getSystemInfo","{}")
    print("systemInfo::"..systemInfo)
    local systemJson    = json.decode(systemInfo)

    CHANNEL_NAME        = systemJson["channel"]
    PLATFORM            = systemJson["platform"]
    require("lua/scene/LoadRes")

    local fileName1 = "lua/parent_module/LuaStart.lua"
    local fileName2 = "lua/parent_module/LuaStart.luac"
    if CCFileUtils:sharedFileUtils():fullPathForFilename(fileName1) ~= fileName1 or CCFileUtils:sharedFileUtils():fullPathForFilename(fileName2) ~= fileName2 then
        require("lua/parent_module/LuaStart")
        Cocos2dVersion = "cocos2d-2.x"
    end

    GlobalV.channel     = systemJson["channel"]
    GlobalV.version     = systemJson["version"]
    GlobalV.platform    = systemJson["platform"]
    GlobalV.deviceid    = systemJson["deviceid"]
    GlobalV.gameid      = systemJson["gameid"]
    GlobalV.phoneModel  = systemJson["phoneModel"]
    GlobalV.apkSign     = systemJson["apkSign"]
    
     --推广应用信息
    -- local promoteJson = GameTool:getString(GlobalV.connectUtil.HOST_URL_GET_PROMOTIN.."appId="..GlobalV.gameid.."&channel="..GlobalV.channel.."&new=1")
    -- -- local promoteJson = Global:sgConnectToHttp(GlobalV.connectUtil.HOST_URL_GET_PROMOTIN.."appId="..GlobalV.gameid.."&channel="..GlobalV.channel.."&new=1","","GET_PROMOTIN")
    -- print("promoteJsonjson"..promoteJson)
    -- if "" ~= promoteJson then 
    --     GlobalV.promoteMsg  = json.decode(promoteJson)
    -- end 
    -- if GlobalV.promoteMsg~= nil and table.nums(GlobalV.promoteMsg)  > 0 then
    --     -- 推广应用图片地址
    --     local proImgURL = GlobalV.promoteMsg["img"]

    --     -- 图片纹理key
    --     local textureKey = GlobalV.promoteMsg["proID"]
    --     if proImgURL ~= nil  and textureKey ~= nil then
    --         -- 下载图片到texture
    --         Global:getHeadForURL(GlobalV.promoteMsg["proID"],"", proImgURL)
    --     end
    -- end
    
    -- 创建启动页
    local sceneLaunch = CCScene:create()
    local launchLayer = LaunchLayer.new()
    sceneLaunch:addChild(launchLayer)
    CCDirector:sharedDirector():runWithScene(sceneLaunch)
end

-- 调用方法：第一个参数为调用的方法，第二个参数为错误信息方法
xpcall(main, __G__TRACKBACK__)